﻿<%@ WebService Language="C#" Class="WebService" %>

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using Telerik.Web.UI;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;
using System.Configuration;


[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
[System.Web.Script.Services.ScriptService]
public class WebService  : System.Web.Services.WebService {

    [WebMethod]
    public SearchBoxData GetItems(SearchBoxContext context)
    {
        DataTable data = GetData(context.Text);

        List<SearchBoxItemData> items = new List<SearchBoxItemData>();

        for (int i = 0; i < data.Rows.Count; i++)
        {
            SearchBoxItemData itemData = new SearchBoxItemData();
            itemData.Text = data.Rows[i]["ProductName"].ToString();
            itemData.Value = data.Rows[i]["ProductId"].ToString();

            items.Add(itemData);
        }

        SearchBoxData result = new SearchBoxData();
        result.Items = items.ToArray();
        return result;
    }

    private static DataTable GetData(string filterString)
    {
        SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString);
        SqlCommand command = new SqlCommand("SELECT [ProductId], [ProductName] FROM [Products] WHERE [ProductName] LIKE '%' + @filterString + '%' ORDER BY [ProductId]");
        command.Parameters.AddWithValue("@filterString", filterString.Replace("%", "[%]").Replace("_", "[_]"));
        command.Connection = connection;
        SqlDataAdapter adapter = new SqlDataAdapter(command);

        DataTable data = new DataTable();
        adapter.Fill(data);
        return data;
    }
    
}